package com.xoado.domain.controller;

import com.alibaba.fastjson.JSONObject;
import com.xoado.domain.service.IdentifyService;
import com.xoado.domain.service.SVMService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

@Controller
public class IdentifyController {

    @Autowired
    IdentifyService analysisService;

    /**
     * 语音文件测试入口
     * @param request
     * @param response
     * @return
     */
    @PostMapping(value = "/identify")
    @ResponseBody
    public JSONObject analysisSpeechText (HttpServletRequest request,
                                          HttpServletResponse response,@RequestBody JSONObject requesJson){
        String text = requesJson.getString("text");
        JSONObject rjson = analysisService.identifyText(text);
        return rjson;
    }

    /**
     * 文本测试入口
     * @param request
     * @param response
     * @return
     */
    @GetMapping(value = "/refreshModel")
    @ResponseBody
    public JSONObject refreshModel (HttpServletRequest request,
                                          HttpServletResponse response){
        JSONObject rjson = new JSONObject();
        SVMService.refreshModel();
        return rjson;
    }

}
